//		Copyright © 1997	Jens Kilian
//
//		This program is free software; you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation; either version 1, or (at your option)
//		any later version.
//
//		This program is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with this program; if not, write to the Free Software
//		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//		The environment variable window for Csound.

#ifndef CSENVMAINWINDOW_H
#define CSENVMAINWINDOW_H

#include <Message.h>
#include <Point.h>
#include <TextControl.h>

#include "CsEnvJob.h"
#include "CsAbstractMainWindow.h"

class CsoundEnvironmentMainWindow : public CsoundAbstractMainWindow
{
public:
	typedef CsoundAbstractMainWindow inherited;
	
	CsoundEnvironmentMainWindow(
		BPoint origin, const char *pTitle,
		const CsoundEnvironmentJob &job = CsoundEnvironmentJob());
	virtual ~CsoundEnvironmentMainWindow(void);

	// Hook functions.
	virtual bool QuitRequested(void);
	
	// Modify environment.
	void SetEnvironment(const CsoundEnvironmentJob &job);
	
protected:
	// Hook functions.
	virtual void ValidJob(bool valid);
	
private:
	CsoundEnvironmentMainWindow(const CsoundEnvironmentMainWindow &);
	CsoundEnvironmentMainWindow &operator =(const CsoundEnvironmentMainWindow &);

	// Controls - directories.
	BTextControl *mpSoundfileDirectory;
	BTextControl *mpSoundSampleDirectory;
	BTextControl *mpSoundAnalysisDirectory;
};

// Utiltity for control creation.
template <class Control>
 	inline Control *CsoundAbstractWindow::*const
	ptrCast(Control *CsoundEnvironmentMainWindow::*const pControl)
	{
		return (Control *CsoundAbstractWindow::*const)pControl;
	}

#endif // CSENVMAINWINDOW_H
