//		Copyright © 1997	Jens Kilian
//
//		This program is free software; you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation; either version 1, or (at your option)
//		any later version.
//
//		This program is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with this program; if not, write to the Free Software
//		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

//		Abstract window class for subordinate options windows.

#ifndef CSABSTRACTOPTIONSWINDOW_H
#define CSABSTRACTOPTIONSWINDOW_H

#include <Point.h>

#include "CsAbstractWindow.h"
class CsoundAbstractMainWindow;

class CsoundAbstractOptionsWindow : public CsoundAbstractWindow
{
public:
	typedef CsoundAbstractWindow inherited;
	
	CsoundAbstractOptionsWindow(
		BPoint origin, const char *pTitle, CsoundAbstractMainWindow &target);
	virtual ~CsoundAbstractOptionsWindow(void);

	// Hook functions.
	virtual bool QuitRequested(void);

protected:
	// Return the controlling main window.
	const CsoundAbstractMainWindow &Target(void) const;
	CsoundAbstractMainWindow &Target(void);

private:
	CsoundAbstractOptionsWindow(const CsoundAbstractOptionsWindow &);
	CsoundAbstractOptionsWindow &operator =(const CsoundAbstractOptionsWindow &);

	// Data members.
	CsoundAbstractMainWindow &mTarget;
};

inline const CsoundAbstractMainWindow &
CsoundAbstractOptionsWindow::Target(void) const
{
	return mTarget;
}

inline CsoundAbstractMainWindow &
CsoundAbstractOptionsWindow::Target(void)
{
	return mTarget;
}

#endif // CSABSTRACTOPTIONSWINDOW_H
