//		Copyright © 1997	Jens Kilian
//
//		This program is free software; you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation; either version 1, or (at your option)
//		any later version.
//
//		This program is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with this program; if not, write to the Free Software
//		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include <Bitmap.h>
#include <GraphicsDefs.h>
#include <Menu.h>
#include <MenuItem.h>

#include "BitmapMenuItem.h"

BitmapMenuItem::BitmapMenuItem(BBitmap *pLabel, BMenu *pMenu)
:	inherited(pMenu),
	mpLabel(pLabel)
{
	// empty
}

BitmapMenuItem::~BitmapMenuItem(void)
{
	delete mpLabel;
	mpLabel = 0;
}

void BitmapMenuItem::GetContentSize(float *pWidth, float *pHeight)
{
	BRect bounds = mpLabel->Bounds();
	*pWidth = bounds.Width();
	*pHeight = bounds.Height();
}

void BitmapMenuItem::DrawContent(void)
{
	BMenu *const pMenu = Menu();
	pMenu->MovePenBy(0, -1.0);		// empirically determined :-(
	pMenu->SetDrawingMode(B_OP_OVER);
	pMenu->DrawBitmap(mpLabel);
}
